searchNodes=[{"doc":"Hierarchical deterministic wallet. It has the following features: Generate mnemonic Generate seed from mnemonic Generate master keys from seed Derive private and public keys from the master key Various utility functions to work with derivation path, keys, crypto addresses","ref":"Cryptopunk.html","title":"Cryptopunk","type":"module"},{"doc":"Generate mnenmonic with the given number of words (24 by default). See https://github.com/bitcoin/bips/blob/master/bip-0039.mediawiki Examples: iex&gt; mnemonic1 = Cryptopunk . create_mnemonic ( ) iex&gt; mnemonic2 = Cryptopunk . create_mnemonic ( ) iex&gt; mnemonic1 |&gt; String . split ( &quot; &quot; ) |&gt; Enum . count ( ) 24 iex&gt; mnemonic1 != mnemonic2 true","ref":"Cryptopunk.html#create_mnemonic/1","title":"Cryptopunk.create_mnemonic/1","type":"function"},{"doc":"Generate mnemonic from entropy. Examples: iex&gt; bytes = &lt;&lt; 6 , 197 , 169 , 93 , 98 , 210 , 82 , 216 , 148 , 177 , 1 , 251 , 142 , 15 , 154 , 85 , 140 , 0 , 13 , 202 , 234 , 160 , 129 , 218 &gt;&gt; iex&gt; Cryptopunk . create_mnemonic_from_entropy ( bytes ) &quot;almost coil firm shield cement hobby fan cage wine idea track prison scale alone close favorite limb still&quot;","ref":"Cryptopunk.html#create_mnemonic_from_entropy/1","title":"Cryptopunk.create_mnemonic_from_entropy/1","type":"function"},{"doc":"Generate seed from mnemonic. See https://github.com/bitcoin/bips/blob/master/bip-0039.mediawiki#from-mnemonic-to-seed Examples: iex&gt; mnemonic = &quot;almost coil firm shield cement hobby fan cage wine idea track prison scale alone close favorite limb still&quot; iex&gt; Cryptopunk . create_seed ( mnemonic ) &lt;&lt; 180 , 208 , 65 , 58 , 208 , 96 , 16 , 14 , 214 , 63 , 190 , 54 , 77 , 169 , 17 , 207 , 191 , 239 , 227 , 252 , 200 , 195 , 135 , 251 , 68 , 70 , 169 , 124 , 100 , 147 , 143 , 61 , 26 , 196 , 128 , 18 , 245 , 89 , 94 , 32 , 11 , 35 , 71 , 132 , 156 , 123 , 140 , 123 , 114 , 55 , 72 , 40 , 57 , 245 , 153 , 249 , 124 , 98 , 130 , 203 , 108 , 168 , 109 , 144 &gt;&gt;","ref":"Cryptopunk.html#create_seed/2","title":"Cryptopunk.create_seed/2","type":"function"},{"doc":"Derives key https://github.com/bitcoin/bips/blob/master/bip-0032.mediawiki Examples: iex&gt; seed = &lt;&lt; 98 , 235 , 236 , 246 , 19 , 205 , 197 , 254 , 187 , 41 , 62 , 19 , 189 , 20 , 24 , 73 , 206 , 187 , 198 , 83 , 160 , 138 , 77 , 155 , 195 , 97 , 140 , 111 , 133 , 102 , 241 , 26 , 176 , 95 , 206 , 198 , 71 , 251 , 118 , 115 , 134 , 215 , 226 , 194 , 62 , 106 , 255 , 94 , 15 , 142 , 227 , 186 , 152 , 88 , 218 , 220 , 184 , 63 , 242 , 30 , 162 , 59 , 32 , 229 &gt;&gt; iex&gt; { :ok , path } = Cryptopunk . parse_path ( &quot;m / 44&#39; / 0&#39; / 0&#39; / 0 / 0&quot; ) iex&gt; seed |&gt; Cryptopunk . master_key_from_seed ( ) |&gt; Cryptopunk . derive_key ( path ) % Cryptopunk.Key { chain_code : &lt;&lt; 166 , 125 , 2 , 213 , 77 , 88 , 124 , 145 , 241 , 251 , 83 , 163 , 21 , 11 , 20 , 34 , 158 , 157 , 179 , 147 , 162 , 212 , 148 , 89 , 28 , 92 , 68 , 126 , 215 , 79 , 147 , 159 &gt;&gt; , depth : 5 , index : 0 , key : &lt;&lt; 214 , 231 , 94 , 203 , 167 , 219 , 125 , 43 , 251 , 91 , 147 , 51 , 32 , 146 , 186 , 215 , 58 , 45 , 104 , 58 , 119 , 114 , 121 , 238 , 155 , 215 , 239 , 189 , 37 , 236 , 27 , 70 &gt;&gt; , parent_fingerprint : &lt;&lt; 205 , 94 , 166 , 92 &gt;&gt; , type : :private }","ref":"Cryptopunk.html#derive_key/2","title":"Cryptopunk.derive_key/2","type":"function"},{"doc":"Deserialize extended key Examples: iex&gt; Cryptopunk . deserialize_key ( &quot;xprv9s21ZrQH143K3bGcMmWrLU2jguNt5HPuMcuW2ZSTmHWPecUNW1hZgfyGyTLZYEALk46YzbEiPL7v3s2SDxgdbhHF7SiKiMAz4kVx9u5gfr9&quot; ) % Cryptopunk.Key { chain_code : &lt;&lt; 153 , 249 , 145 , 92 , 65 , 77 , 50 , 249 , 120 , 90 , 178 , 30 , 41 , 27 , 73 , 128 , 74 , 201 , 91 , 250 , 143 , 238 , 129 , 247 , 115 , 87 , 161 , 107 , 123 , 63 , 84 , 243 &gt;&gt; , depth : 0 , index : 0 , key : &lt;&lt; 50 , 8 , 92 , 222 , 223 , 155 , 132 , 50 , 53 , 227 , 114 , 79 , 88 , 11 , 248 , 24 , 239 , 76 , 236 , 39 , 195 , 198 , 112 , 133 , 224 , 41 , 65 , 138 , 91 , 47 , 111 , 43 &gt;&gt; , parent_fingerprint : &lt;&lt; 0 , 0 , 0 , 0 &gt;&gt; , type : :private }","ref":"Cryptopunk.html#deserialize_key/1","title":"Cryptopunk.deserialize_key/1","type":"function"},{"doc":"Generate master private key from seed See https://github.com/bitcoin/bips/blob/master/bip-0032.mediawiki#master-key-generation Examples: iex&gt; seed = &lt;&lt; 98 , 235 , 236 , 246 , 19 , 205 , 197 , 254 , 187 , 41 , 62 , 19 , 189 , 20 , 24 , 73 , 206 , 187 , 198 , 83 , 160 , 138 , 77 , 155 , 195 , 97 , 140 , 111 , 133 , 102 , 241 , 26 , 176 , 95 , 206 , 198 , 71 , 251 , 118 , 115 , 134 , 215 , 226 , 194 , 62 , 106 , 255 , 94 , 15 , 142 , 227 , 186 , 152 , 88 , 218 , 220 , 184 , 63 , 242 , 30 , 162 , 59 , 32 , 229 &gt;&gt; iex&gt; Cryptopunk . master_key_from_seed ( seed ) % Cryptopunk.Key { chain_code : &lt;&lt; 153 , 249 , 145 , 92 , 65 , 77 , 50 , 249 , 120 , 90 , 178 , 30 , 41 , 27 , 73 , 128 , 74 , 201 , 91 , 250 , 143 , 238 , 129 , 247 , 115 , 87 , 161 , 107 , 123 , 63 , 84 , 243 &gt;&gt; , key : &lt;&lt; 50 , 8 , 92 , 222 , 223 , 155 , 132 , 50 , 53 , 227 , 114 , 79 , 88 , 11 , 248 , 24 , 239 , 76 , 236 , 39 , 195 , 198 , 112 , 133 , 224 , 41 , 65 , 138 , 91 , 47 , 111 , 43 &gt;&gt; , type : :private , depth : 0 , parent_fingerprint : &lt;&lt; 0 , 0 , 0 , 0 &gt;&gt; , index : 0 }","ref":"Cryptopunk.html#master_key_from_seed/1","title":"Cryptopunk.master_key_from_seed/1","type":"function"},{"doc":"Parse derivation path See https://github.com/bitcoin/bips/blob/master/bip-0044.mediawiki Examples: iex&gt; Cryptopunk . parse_path ( &quot;m / 44&#39; / 0&#39; / 0&#39; / 0 / 0&quot; ) { :ok , % Cryptopunk.Derivation.Path { account : 0 , address_index : 0 , change : 0 , coin_type : 0 , purpose : 44 , type : :private } }","ref":"Cryptopunk.html#parse_path/1","title":"Cryptopunk.parse_path/1","type":"function"},{"doc":"Serialize extended key See https://github.com/bitcoin/bips/blob/master/bip-0032.mediawiki#Serialization_format Examples: iex&gt; seed = &lt;&lt; 98 , 235 , 236 , 246 , 19 , 205 , 197 , 254 , 187 , 41 , 62 , 19 , 189 , 20 , 24 , 73 , 206 , 187 , 198 , 83 , 160 , 138 , 77 , 155 , 195 , 97 , 140 , 111 , 133 , 102 , 241 , 26 , 176 , 95 , 206 , 198 , 71 , 251 , 118 , 115 , 134 , 215 , 226 , 194 , 62 , 106 , 255 , 94 , 15 , 142 , 227 , 186 , 152 , 88 , 218 , 220 , 184 , 63 , 242 , 30 , 162 , 59 , 32 , 229 &gt;&gt; iex&gt; seed |&gt; Cryptopunk . master_key_from_seed ( ) |&gt; Cryptopunk . serialize_key ( &lt;&lt; 4 , 136 , 173 , 228 &gt;&gt; ) &quot;xprv9s21ZrQH143K3bGcMmWrLU2jguNt5HPuMcuW2ZSTmHWPecUNW1hZgfyGyTLZYEALk46YzbEiPL7v3s2SDxgdbhHF7SiKiMAz4kVx9u5gfr9&quot;","ref":"Cryptopunk.html#serialize_key/2","title":"Cryptopunk.serialize_key/2","type":"function"},{"doc":"This module provides Base58 and Base58Check data encoding and decoding functions. The following alphabets are supported for encoding and decoding, for both Base58 and Base58Check: Bitcoin Flickr Ripple Note that IPFS uses the same alphabet as Bitcoin. Since this alphabet appeared in Bitcoin first, it will be referred to hereafter as Bitcoin, though it can be used for encoding and decoding data from IPFS without issue. Overview Base58 is a Base58 and Base58Check library that tries to make pragmatic compromises, while maintaining best practices with regard to Elixir and BEAM performance. It has no external dependencies and supports adding additional values with a simple update of an internal map. Additionally, Cryptopunk.B58 encodes and decodes data in a consistent manner - plain binary in, plain binary out. No additional steps, clever hacks, or assumptions are made with regard to input and output. Furthermore, the library is relatively consistent with the approach taken in the Elixir core Base library. In cases where exceptions may be more common, ! suffixed functions are provided, ex: base58_decode vs base58_decode! . Base58Check data also supports two versions of encoding and decoding respectively. Version binaries are assumed to be input and output via functions prefixed with version , ex: version_encode58_check!/2 . A versioned binary can also be created using version_binary/2 . Version arguments are also consistently arranged so that they may be easily piped using Elixir. Unversioned binaries may also be encoded and decoded and simply use the same pattern of functions without the version prefix in the name, ex: encode58_check! . Ensure that when encoding and decoding, you use the appropriate alphabet. For example, if you encode using the Flickr alphabet, decode using the same alphabet. If you do not control encoding, ensure you know up-front what alphabet is used. Base58 will often decode using the incorrect alphabet without an error, but produce wrong results. Base58Check on the other hand will typically fail up-front due to the checksum being incorrect. It is thus possible, but not advisable to try to brute-force detect the alphabet for Base58Check using the alphabets/0 function with a reduce_while/3 function as a last resort. Ensure the Erlang &quot;crypto&quot; module is installed. There are some OS distributions that do not include this. Why Base58 Encoding The most compelling reason to use Base58 is if you are using or interfacing any technology that already uses it. This includes various crypto-currencies such as Bitcoin, Blockchain-based experiments, various distributed systems, IPFS, Flickr URLs, and many more. Generally, you can also decide to use Base58 if you want an unambiguous encoding that is less prone to errors when read by a human. Moreover, you can use Base58Check when you need to checksum and/or version your data. Taken from the original Bitcoin source code: Why base - 58 instead of standard base - 64 encoding? - Don &#39;t want 0OIl characters that look the same in some fonts and could be used to create visually identical looking account numbers. - A string with non-alphanumeric characters is not as easily accepted as an account number. - E-mail usually won&#39; t line - break if there &#39;s no punctuation to break at. - Double-clicking selects the whole number as one word if it&#39; s all alphanumeric . Base58Check Encoding The following features are outlined per the bitcoin wiki regarding Base58Check: * An arbitrarily sized payload . * A set of 58 alphanumeric symbols consisting of easily distinguished uppercase and lowercase letters ( 0 OIl are not used ) * One byte of version / application information . Bitcoin addresses use 0x00 for this byte ( future ones may use 0x05 ) . * Four bytes ( 32 bits ) of SHA256 - based error checking code . This code can be used to automatically detect and possibly correct typographical errors . * An extra step for preservation of leading zeroes in the data . ## Base58Check vs Base58 Encoding You should use Base58Check over Base58 encoding if any of the features it presents are appealing to you . Perhaps the most compelling reason to use Base58Check , however , is the ability to version data and embed a checksum . Generally , Base58 should perform better as Base58Check is a layer on top of Base58 . The checksum in Base58Check , however , will usually prevent accidental decoding using the wrong alphabet . Why Not Base58 or Base58Check Base58 and Base58Check are suitable and desirable for many reasons ranging from protection from character ambiguity to checksums to real-world software usage. Nevertheless, there are several considerations you should evaluate before selecting Base58 or Base58Check. Among the reasons not to use Base58 or Base58Check include: Speed Usage of div and mod . Both these operations are slow, especially in Elixir. Many other encodings are not performance limited by these operations and thus faster. It may be possible to gain more speed using a technique where div and mod (divmod) together are replaced with a CRC + table approach to avoid the overhead. This is more readily doable in C or C++. It is not clear whether doing this in Elixir has benefits nor if it is worth it in terms of stability and performance doing so via a NIF. Base58Check introduces additional overhead via sha-256, extra binary manipulation, and checksum verification during decoding. Dynamic alphabets Base58 is not as amenable to dynamic alphabets. This library also intentionally ignores this constraint. The main reason is that there are some characters that are counter to the goals of Base58. Losing performance to support a dynamic alphabet is probably not a tradeoff you should be making. Note that dynamic alphabets that follow the guidelines of existing alphabets can be added with a simple compile-time updates of this library. Payload size Some encodings may produce a smaller payload size relative to the source data. You can compress a Base58 payload, but it is not an inherent goal of the algorithm itself. Selecting an Alphabet You should select an alphabet that aligns with your inteded use-cases. If in doubt, start with the bitcoin ( :btc ) alphabet. For usage with URLs such as shorteners or parameters, the Flickr ( :flickr ) alphabet has seen some real-world usage and is thus worth considering. If you need to add an alphabet, it is suggested to do so at compile time by updating the alphabet_meta map found in the source. It is strongly advised to use an existing alphabet, however. Base58 Bitcoin Alphabet | Value | Encoding | Value | Encoding | Value | Encoding | Value | Encoding | | -- -- -- :| -- -- -- -- - :| -- -- -- :| -- -- -- -- - :| -- -- -- :| -- -- -- -- - :| -- -- -- :| -- -- -- -- - :| | 0 | 1 | 17 | J | 34 | b | 51 | t | | 1 | 2 | 18 | K | 35 | c | 52 | u | | 2 | 3 | 19 | L | 36 | d | 53 | v | | 3 | 4 | 20 | M | 37 | e | 54 | w | | 4 | 5 | 21 | N | 38 | f | 55 | x | | 5 | 6 | 22 | P | 39 | g | 56 | y | | 6 | 7 | 23 | Q | 40 | h | 57 | z | | 7 | 8 | 24 | R | 41 | i | | | | 8 | 9 | 25 | S | 42 | j | | | | 9 | A | 26 | T | 43 | k | | | | 10 | B | 27 | U | 44 | m | | | | 11 | C | 28 | V | 45 | n | | | | 12 | D | 29 | W | 46 | o | | | | 13 | E | 30 | X | 47 | p | | | | 14 | F | 31 | Y | 48 | q | | | | 15 | G | 32 | Z | 49 | r | | | | 16 | H | 33 | a | 50 | s | | | Base58 Flickr Alphabet | Value | Encoding | Value | Encoding | Value | Encoding | Value | Encoding | | -- -- -- :| -- -- -- -- - :| -- -- -- :| -- -- -- -- - :| -- -- -- :| -- -- -- -- - :| -- -- -- :| -- -- -- -- - :| | 0 | 1 | 17 | i | 34 | A | 51 | T | | 1 | 2 | 18 | j | 35 | B | 52 | U | | 2 | 3 | 19 | k | 36 | C | 53 | V | | 3 | 4 | 20 | m | 37 | D | 54 | W | | 4 | 5 | 21 | n | 38 | E | 55 | X | | 5 | 6 | 22 | o | 39 | F | 56 | Y | | 6 | 7 | 23 | p | 40 | G | 57 | Z | | 7 | 8 | 24 | q | 41 | H | | | | 8 | 9 | 25 | r | 42 | J | | | | 9 | a | 26 | s | 43 | K | | | | 10 | b | 27 | t | 44 | L | | | | 11 | c | 28 | u | 45 | M | | | | 12 | d | 29 | v | 46 | N | | | | 13 | e | 30 | w | 47 | P | | | | 14 | f | 31 | x | 48 | Q | | | | 15 | g | 32 | y | 49 | R | | | | 16 | h | 33 | z | 50 | S | | | Base58 Ripple Alphabet | Value | Encoding | Value | Encoding | Value | Encoding | Value | Encoding | | -- -- -- :| -- -- -- -- - :| -- -- -- :| -- -- -- -- - :| -- -- -- :| -- -- -- -- - :| -- -- -- :| -- -- -- -- - :| | 0 | r | 17 | J | 34 | b | 51 | t | | 1 | p | 18 | K | 35 | c | 52 | u | | 2 | s | 19 | L | 36 | d | 53 | v | | 3 | h | 20 | M | 37 | e | 54 | A | | 4 | n | 21 | 4 | 38 | C | 55 | x | | 5 | a | 22 | P | 39 | g | 56 | y | | 6 | f | 23 | Q | 40 | 6 | 57 | z | | 7 | 3 | 24 | R | 41 | 5 | | | | 8 | 9 | 25 | S | 42 | j | | | | 9 | w | 26 | T | 43 | k | | | | 10 | B | 27 | 7 | 44 | m | | | | 11 | U | 28 | V | 45 | 8 | | | | 12 | D | 29 | W | 46 | o | | | | 13 | N | 30 | X | 47 | F | | | | 14 | E | 31 | Y | 48 | q | | | | 15 | G | 32 | Z | 49 | i | | | | 16 | H | 33 | 2 | 50 | 1 | | | References Base58 Base58Check Base58 Flickr Elixir Base Module Ripple Github Bitcoin Base58 Implementation Erlang Crypto Module","ref":"Cryptopunk.B58.html","title":"Cryptopunk.B58","type":"module"},{"doc":"Lists all the alphabets available as identifiers to use with Base58. Examples iex&gt; Cryptopunk.B58 . alphabets ( ) [ :btc , :flickr , :ripple ]","ref":"Cryptopunk.B58.html#alphabets/0","title":"Cryptopunk.B58.alphabets/0","type":"macro"},{"doc":"Decodes a Base58 binary. An {:error, reason} tuple is returned if the binary contains characters that are invalid for the given alphabet. Examples iex&gt; Cryptopunk.B58 . decode58 ( &quot;59QpGHkaSK8tngYpe9h17cseyAEGc&quot; , alphabet : :btc ) { :ok , &quot;Cheese Platter Please&quot; } iex&gt; Cryptopunk.B58 . decode58 ( &quot;2nePN7syqoQe2mfeY&quot; , alphabet : :flickr ) { :ok , &quot;Hello Sailor&quot; } iex&gt; Cryptopunk.B58 . decode58 ( &quot;02nePN7syqoQe2mfeY&quot; , alphabet : :flickr ) { :error , &quot;non-alphabet digit found: \\&quot; 0 \\&quot; (byte 48)&quot; }","ref":"Cryptopunk.B58.html#decode58/2","title":"Cryptopunk.B58.decode58/2","type":"function"},{"doc":"Decodes a Base58 binary. An ArgumentError exception is raised if the binary contains characters that are invalid for the given alphabet. Examples iex&gt; Cryptopunk.B58 . decode58! ( &quot;59QpGHkaSK8tngYpe9h17cseyAEGc&quot; ) &quot;Cheese Platter Please&quot; iex&gt; Cryptopunk.B58 . decode58! ( &quot;asDvaq68ktFaubY7KsnvBFMMD5Q8cd9PhGma3YcPqoWXX2aJoiaK1kc65gn&quot; , alphabet : :ripple ) &quot;Decode using the alphabet it was encoded in&quot; iex&gt; Cryptopunk.B58 . decode58! ( &quot;2zPJuvDvDNbavb7zdUVM9niBSHNTjPni85f8hPLJ119awVLKud3kWU5LsRGiqkzav8wD6MFj2QshN3b8SyTEpkG2pYcSAioeUUDe6wqhigji4vkBVQoBJ9mPLmySgjQyy8FrYu3rd&quot; , alphabet : :btc ) |&gt; Base . decode16! ( ) &quot;0088C2D2FA846282C870A76CADECBE45C4ACD72BB655DA1216&quot;","ref":"Cryptopunk.B58.html#decode58!/2","title":"Cryptopunk.B58.decode58!/2","type":"function"},{"doc":"Decodes a Base58Check binary. An {:error, reason} tuple is returned if the binary contains characters that are invalid for the given alphabet or if the checksum bytes do not match the payload. Examples iex&gt; Cryptopunk.B58 . decode58_check ( &quot;QGgq7M6oMmgLQiWY9SUgo5QoaK6FH44nM&quot; ) { :ok , { &quot;Backstrom for Selke&quot; , &lt;&lt; 255 &gt;&gt; } } iex&gt; Cryptopunk.B58 . decode58_check! ( &quot;17B1aKcMUBrrX9t6Y7ZUSkDoedGLiybgnJ&quot; , alphabet : :flickr ) { &quot;Hot Delicious Treats&quot; , &lt;&lt; 0 &gt;&gt; } iex&gt; Cryptopunk.B58 . decode58_check ( &quot;QGgq7M6oMmgLQiWY9SUgo5QoaK6FH44n_&quot; , alphabet : :btc ) { :error , &quot;non-alphabet digit found: \\&quot; _ \\&quot; (byte 95)&quot; } iex&gt; Cryptopunk.B58 . decode58_check ( &quot;QGgq7M6oMmgLQiWY9SUgo5QoaK6FH44nM&quot; , alphabet : :ripple ) { :error , &quot;Invalid checksum.&quot; }","ref":"Cryptopunk.B58.html#decode58_check/2","title":"Cryptopunk.B58.decode58_check/2","type":"function"},{"doc":"Decodes a Base58Check binary. An ArgumentError exception is raised if the binary contains characters that are invalid for the given alphabet or if the checksum bytes do not match the payload. Examples iex&gt; Cryptopunk.B58 . decode58_check! ( &quot;12nwcb8vmxv3waEzzPtaY3XBmWbwvGvqw&quot; , alphabet : :flickr ) { &quot;Backstrom for Selke&quot; , &lt;&lt; 0 &gt;&gt; } iex&gt; Cryptopunk.B58 . decode58_check! ( &quot;ftyYJFWLdZWzNfyFqPGXGpxM6aFNnTkqmz1QwcoT3eQAQPb9V4bRQScejwWQWTR8&quot; , alphabet : :ripple ) { &quot;No one wants to play Sega Genesis with you&quot; , &lt;&lt; 14 &gt;&gt; } iex&gt; Cryptopunk.B58 . decode58_check! ( &quot;2mzYnhGdFMacGVTrvyZsnqDGPqWFefouMQA&quot; ) { &lt;&lt; 245 , 74 , 88 , 81 , 233 , 55 , 43 , 135 , 129 , 10 , 142 , 96 , 205 , 210 , 231 , 207 , 216 , 11 , 110 , 49 &gt;&gt; , &lt;&lt; 255 &gt;&gt; }","ref":"Cryptopunk.B58.html#decode58_check!/2","title":"Cryptopunk.B58.decode58_check!/2","type":"function"},{"doc":"Encodes a binary in Base58. Examples iex&gt; Cryptopunk.B58 . encode58 ( &quot;Some chicken is better than no chicken&quot; ) &quot;DLrwGKtrzZkxaLwqpwBBbkgFiEGTYhhzEpjXuj5R2DZPGzbXfeVK&quot; iex&gt; Cryptopunk.B58 . encode58 ( &quot;Some chicken is better than no chicken&quot; , alphabet : :btc ) &quot;DLrwGKtrzZkxaLwqpwBBbkgFiEGTYhhzEpjXuj5R2DZPGzbXfeVK&quot; iex&gt; Cryptopunk.B58 . encode58 ( &quot;The T in Tacos stands for terrific&quot; , alphabet : :flickr ) &quot;2UF2YLgW2MQSutxJWpcW6afxo1YbVm4ZnXociLQ1eExXRwK&quot; iex&gt; &quot;536D656C6C73206C696B652061206C6F636B657220726F6F6D20696E2068657265&quot; |&gt; Base . decode16! ( ) |&gt; Cryptopunk.B58 . encode58 ( alphabet : :ripple ) &quot;R8RKuNXBxzb1Ai6HrP3mHmgyBEKmWjp944zS4Y9Q7hsPS&quot;","ref":"Cryptopunk.B58.html#encode58/2","title":"Cryptopunk.B58.encode58/2","type":"function"},{"doc":"Encodes a binary in Base58Check using the given version byte. Examples iex&gt; Cryptopunk.B58 . encode58_check ( &quot;So Afraid of failure&quot; , &lt;&lt; 1 &gt;&gt; , alphabet : :btc ) { :ok , &quot;XwmCCcWGbEjGsJk4THsxw28EcQuz6TYyu&quot; } iex&gt; Cryptopunk.B58 . encode58_check ( &quot;Incapable coworker lacking understanding what a byte is&quot; , &lt;&lt; 1 , 2 &gt;&gt; , alphabet : :btc ) { :error , &quot;version must be a single byte binary or unsigned integer, data must be a binary.&quot; }","ref":"Cryptopunk.B58.html#encode58_check/3","title":"Cryptopunk.B58.encode58_check/3","type":"function"},{"doc":"Encodes a binary in Base58Check using the given version byte. Examples iex&gt; Cryptopunk.B58 . encode58_check! ( &quot;Lost my sauce, sorry boss.&quot; , 0 ) &quot;1GKJd5qu8gaFbd4tHVPF6q8ZtzER5ttJSwLTN2A5MT&quot; iex&gt; Cryptopunk.B58 . encode58_check! ( &quot;Lost my sauce, sorry boss.&quot; , 1 , alphabet : :btc ) &quot;29cSfWnUdLoFyrRquaF4fQ2xnKSMg8TWenhe89Mc95&quot; iex&gt; Cryptopunk.B58 . encode58_check! ( &quot;Lettuceless Burritos&quot; , &quot;m&quot; , alphabet : :ripple ) &quot;kyo6DdGZMd7yc1EmNVz2jh4sEc3qUNBY1D&quot; iex&gt; &quot;466F6F20426172204578616D706C657320617265207265616C6C792064616D6E20737475706964&quot; |&gt; Base . decode16! ( ) |&gt; Cryptopunk.B58 . encode58_check! ( &quot;2&quot; , alphabet : :flickr ) &quot;hm63nMd9884zRLqGD2cYDUgk3JR1EEEbP6UQfEU2uPAoZfQe3VrXHfYvRkok&quot;","ref":"Cryptopunk.B58.html#encode58_check!/3","title":"Cryptopunk.B58.encode58_check!/3","type":"function"},{"doc":"Versions a binary according to the Base58Check rules. Only use with unversioned binaries. An ArgumentError is raised if the version is not a single byte unsigned integer (uint8). Examples iex&gt; Cryptopunk.B58 . version_binary ( &quot;Chicken Recipe&quot; , 42 ) &quot;*Chicken Recipe&quot; iex&gt; Cryptopunk.B58 . version_binary ( &quot;Chicken Recipe&quot; , &lt;&lt; 255 &gt;&gt; ) &lt;&lt; 255 , 67 , 104 , 105 , 99 , 107 , 101 , 110 , 32 , 82 , 101 , 99 , 105 , 112 , 101 &gt;&gt; iex&gt; Cryptopunk.B58 . version_binary ( &quot;Chicken Recipe&quot; , &lt;&lt; 0 &gt;&gt; ) |&gt; Cryptopunk.B58 . version_encode58_check! ( ) &quot;13oALC94NVeHBQsneF6tYRmW4R&quot;","ref":"Cryptopunk.B58.html#version_binary/2","title":"Cryptopunk.B58.version_binary/2","type":"function"},{"doc":"Decodes a Base58Check binary with the version byte included in the returned binary. An {:error, reason} tuple is returned if the binary contains characters that are invalid for the given alphabet or if the checksum bytes do not match the payload. Examples iex&gt; Cryptopunk.B58 . version_decode58_check ( &quot;2XLgTmqxf6wu4zAwBAb2hvezGWht&quot; ) { :ok , &quot;mSeal of Quality&quot; } iex&gt; Cryptopunk.B58 . version_decode58_check ( &quot;2XLgTmqxf6wu4zAwBAb2hvezGWht&quot; , alphabet : :flickr ) { :error , &quot;Invalid checksum.&quot; } iex&gt; Cryptopunk.B58 . version_decode58_check ( &quot;2XLgTmqxf6wu4zAwBAb2hvezGWht0&quot; , alphabet : :btc ) { :error , &quot;non-alphabet digit found: \\&quot; 0 \\&quot; (byte 48)&quot; } iex&gt; Cryptopunk.B58 . version_decode58_check ( &quot;2QRkeNpTrYPiooUJjcubi1fprQ7aB8XvxSZ2wa4JQeBryrPVCvvkcY5NkXeptH6UzjKBBznXp58MWv4TTBvSHgeyjwPtY&quot; , alphabet : :ripple ) { :ok , &lt;&lt; 255 , 83 , 116 , 111 , 112 , 32 , 117 , 115 , 105 , 110 , 103 , 32 , 69 , 110 , 117 , 109 , 46 , 97 , 116 , 32 , 116 , 111 , 32 , 108 , 111 , 111 , 107 , 117 , 112 , 32 , 116 , 104 , 105 , 110 , 103 , 115 , 32 , 105 , 110 , 32 , 99 , 111 , 100 , 101 , 99 , 115 , 46 , 32 , 75 , 110 , 111 , 119 , 32 , 121 , 111 , 117 , 114 , 32 , 66 , 105 , 103 , 32 , 79 , 46 &gt;&gt; }","ref":"Cryptopunk.B58.html#version_decode58_check/2","title":"Cryptopunk.B58.version_decode58_check/2","type":"function"},{"doc":"Decodes a Base58Check binary with the version byte included in the returned binary. An ArgumentError exception is raised if the binary contains characters that are invalid for the given alphabet or if the checksum bytes do not match the payload. Examples iex&gt; Cryptopunk.B58 . version_decode58_check! ( &quot;2XLgTmqxf6wu4zAwBAb2hvezGWht&quot; ) &quot;mSeal of Quality&quot; iex&gt; Cryptopunk.B58 . version_decode58_check! ( &quot;5XtVTWqqaYj7VUodxQwwgnioaGCoB1fVFzMSXLfQWBiUmsEfo6oJ73CpJojLDuYa3fFE77uvAax4ctzBT17me&quot; , alphabet : :flickr ) &quot;SEvery library says it is fast. Surely, they are all fast.&quot; iex&gt; Cryptopunk.B58 . version_decode58_check! ( &quot;YXUaKUi6gkm3DRXp8hDrbB&quot; , alphabet : :ripple ) &lt;&lt; 255 , 66 , 114 , 111 , 103 , 114 , 97 , 109 , 109 , 101 , 114 , 115 &gt;&gt;","ref":"Cryptopunk.B58.html#version_decode58_check!/2","title":"Cryptopunk.B58.version_decode58_check!/2","type":"function"},{"doc":"Encodes a binary in Base58Check using the first byte as the version byte. Assumes the binary is already versioned. Examples iex&gt; Cryptopunk.B58 . version_encode58_check ( &lt;&lt; 5 , &quot;256 versions ought to be enough for anyone&quot; &gt;&gt; ) { :ok , &quot;3WGnVcRSYcejzu1tmjqG36i8zGFhPH5v7399paTXYSvCQPRsqSa86CcnRUPVJxXw&quot; } iex&gt; Cryptopunk.B58 . version_encode58_check ( &quot;1Mad Lad&quot; , alphabet : :ripple ) { :ok , &quot;vx82hmfYGg4kdDK5&quot; } iex&gt; Cryptopunk.B58 . version_encode58_check ( &lt;&lt; 255 , &quot;Push the limits until the car starts&quot; &gt;&gt; , alphabet : :flickr ) { :ok , &quot;XZABbyyTLAtpXB4uyan6stxnyFhPH2kbr1v6j26SBAvDqrQi8GGBDKxs&quot; }","ref":"Cryptopunk.B58.html#version_encode58_check/2","title":"Cryptopunk.B58.version_encode58_check/2","type":"function"},{"doc":"Encodes a binary in Base58Check using the first byte as the version byte. Assumes the binary is already versioned. Examples iex&gt; Cryptopunk.B58 . version_encode58_check! ( &lt;&lt; 5 , &quot;256 versions ought to be enough for anyone&quot; &gt;&gt; ) &quot;3WGnVcRSYcejzu1tmjqG36i8zGFhPH5v7399paTXYSvCQPRsqSa86CcnRUPVJxXw&quot; iex&gt; Cryptopunk.B58 . version_encode58_check! ( &quot;1Mad Lad&quot; , alphabet : :ripple ) &quot;vx82hmfYGg4kdDK5&quot; iex&gt; Cryptopunk.B58 . version_encode58_check! ( &lt;&lt; 255 , &quot;Push the limits until the car starts&quot; &gt;&gt; , alphabet : :flickr ) &quot;XZABbyyTLAtpXB4uyan6stxnyFhPH2kbr1v6j26SBAvDqrQi8GGBDKxs&quot;","ref":"Cryptopunk.B58.html#version_encode58_check!/2","title":"Cryptopunk.B58.version_encode58_check!/2","type":"function"},{"doc":"An alphabet ID atom that corresponds to the intended alphabet to be used for encoding or decoding.","ref":"Cryptopunk.B58.html#t:alphabet/0","title":"Cryptopunk.B58.alphabet/0","type":"type"},{"doc":"A Base58 encoded binary.","ref":"Cryptopunk.B58.html#t:b58_binary/0","title":"Cryptopunk.B58.b58_binary/0","type":"type"},{"doc":"A Base58Check encoded binary","ref":"Cryptopunk.B58.html#t:b58check_binary/0","title":"Cryptopunk.B58.b58check_binary/0","type":"type"},{"doc":"1-byte version binary","ref":"Cryptopunk.B58.html#t:version/0","title":"Cryptopunk.B58.version/0","type":"type"},{"doc":"Unsigned single-byte integer (unint8 commonly)","ref":"Cryptopunk.B58.html#t:version_integer/0","title":"Cryptopunk.B58.version_integer/0","type":"type"},{"doc":"A binary where the first byte is assumed to be a version.","ref":"Cryptopunk.B58.html#t:versioned_binary/0","title":"Cryptopunk.B58.versioned_binary/0","type":"type"},{"doc":"Bitcoin address generation logic","ref":"Cryptopunk.Crypto.Bitcoin.html","title":"Cryptopunk.Crypto.Bitcoin","type":"module"},{"doc":"","ref":"Cryptopunk.Crypto.Bitcoin.html#address/2","title":"Cryptopunk.Crypto.Bitcoin.address/2","type":"function"},{"doc":"Dogecoin address generation logic. It's similar to bitcoin","ref":"Cryptopunk.Crypto.Dogecoin.html","title":"Cryptopunk.Crypto.Dogecoin","type":"module"},{"doc":"","ref":"Cryptopunk.Crypto.Dogecoin.html#address/2","title":"Cryptopunk.Crypto.Dogecoin.address/2","type":"function"},{"doc":"Ethereum address generation logic","ref":"Cryptopunk.Crypto.Ethereum.html","title":"Cryptopunk.Crypto.Ethereum","type":"module"},{"doc":"","ref":"Cryptopunk.Crypto.Ethereum.html#address/1","title":"Cryptopunk.Crypto.Ethereum.address/1","type":"function"},{"doc":"Implements key derivation logic. See https://github.com/bitcoin/bips/blob/master/bip-0032.mediawiki","ref":"Cryptopunk.Derivation.html","title":"Cryptopunk.Derivation","type":"module"},{"doc":"","ref":"Cryptopunk.Derivation.html#derive/2","title":"Cryptopunk.Derivation.derive/2","type":"function"},{"doc":"","ref":"Cryptopunk.Derivation.html#do_derive/2","title":"Cryptopunk.Derivation.do_derive/2","type":"function"},{"doc":"Utility functions to work with deriviation path See https://github.com/bitcoin/bips/blob/master/bip-0044.mediawiki","ref":"Cryptopunk.Derivation.Path.html","title":"Cryptopunk.Derivation.Path","type":"module"},{"doc":"","ref":"Cryptopunk.Derivation.Path.html#is_hardened/1","title":"Cryptopunk.Derivation.Path.is_hardened/1","type":"macro"},{"doc":"","ref":"Cryptopunk.Derivation.Path.html#is_normal/1","title":"Cryptopunk.Derivation.Path.is_normal/1","type":"macro"},{"doc":"","ref":"Cryptopunk.Derivation.Path.html#new/1","title":"Cryptopunk.Derivation.Path.new/1","type":"function"},{"doc":"","ref":"Cryptopunk.Derivation.Path.html#parse/1","title":"Cryptopunk.Derivation.Path.parse/1","type":"function"},{"doc":"","ref":"Cryptopunk.Derivation.Path.html#to_raw_path/1","title":"Cryptopunk.Derivation.Path.to_raw_path/1","type":"function"},{"doc":"","ref":"Cryptopunk.Derivation.Path.html#two_power_31/0","title":"Cryptopunk.Derivation.Path.two_power_31/0","type":"function"},{"doc":"","ref":"Cryptopunk.Derivation.Path.html#t:raw_path/0","title":"Cryptopunk.Derivation.Path.raw_path/0","type":"type"},{"doc":"","ref":"Cryptopunk.Derivation.Path.html#t:t/0","title":"Cryptopunk.Derivation.Path.t/0","type":"type"},{"doc":"Utility functions to work with keys","ref":"Cryptopunk.Key.html","title":"Cryptopunk.Key","type":"module"},{"doc":"","ref":"Cryptopunk.Key.html#deserialize/1","title":"Cryptopunk.Key.deserialize/1","type":"function"},{"doc":"","ref":"Cryptopunk.Key.html#master_key/1","title":"Cryptopunk.Key.master_key/1","type":"function"},{"doc":"","ref":"Cryptopunk.Key.html#new/1","title":"Cryptopunk.Key.new/1","type":"function"},{"doc":"","ref":"Cryptopunk.Key.html#new_master_private/1","title":"Cryptopunk.Key.new_master_private/1","type":"function"},{"doc":"","ref":"Cryptopunk.Key.html#new_master_public/1","title":"Cryptopunk.Key.new_master_public/1","type":"function"},{"doc":"","ref":"Cryptopunk.Key.html#new_private/1","title":"Cryptopunk.Key.new_private/1","type":"function"},{"doc":"","ref":"Cryptopunk.Key.html#new_public/1","title":"Cryptopunk.Key.new_public/1","type":"function"},{"doc":"","ref":"Cryptopunk.Key.html#public_from_private/1","title":"Cryptopunk.Key.public_from_private/1","type":"function"},{"doc":"","ref":"Cryptopunk.Key.html#serialize/2","title":"Cryptopunk.Key.serialize/2","type":"function"},{"doc":"","ref":"Cryptopunk.Key.html#t:t/0","title":"Cryptopunk.Key.t/0","type":"type"},{"doc":"Implements mnemonic generation logic. See https://github.com/bitcoin/bips/blob/master/bip-0039.mediawiki","ref":"Cryptopunk.Mnemonic.html","title":"Cryptopunk.Mnemonic","type":"module"},{"doc":"","ref":"Cryptopunk.Mnemonic.html#create/1","title":"Cryptopunk.Mnemonic.create/1","type":"function"},{"doc":"","ref":"Cryptopunk.Mnemonic.html#create_from_entropy/1","title":"Cryptopunk.Mnemonic.create_from_entropy/1","type":"function"},{"doc":"Implements seed generation logic. See https://github.com/bitcoin/bips/blob/master/bip-0039.mediawiki#from-mnemonic-to-seed","ref":"Cryptopunk.Seed.html","title":"Cryptopunk.Seed","type":"module"},{"doc":"","ref":"Cryptopunk.Seed.html#create/2","title":"Cryptopunk.Seed.create/2","type":"function"},{"doc":"Utility functions","ref":"Cryptopunk.Utils.html","title":"Cryptopunk.Utils","type":"module"},{"doc":"","ref":"Cryptopunk.Utils.html#compress_public_key/1","title":"Cryptopunk.Utils.compress_public_key/1","type":"function"},{"doc":"","ref":"Cryptopunk.Utils.html#decompress_public_key/1","title":"Cryptopunk.Utils.decompress_public_key/1","type":"function"},{"doc":"","ref":"Cryptopunk.Utils.html#hmac_sha512/2","title":"Cryptopunk.Utils.hmac_sha512/2","type":"function"},{"doc":"","ref":"Cryptopunk.Utils.html#ripemd160_hash/1","title":"Cryptopunk.Utils.ripemd160_hash/1","type":"function"},{"doc":"","ref":"Cryptopunk.Utils.html#sha256_hash/1","title":"Cryptopunk.Utils.sha256_hash/1","type":"function"}]